// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * Generation reading profile
 * </pre>
 *
 * Protobuf type {@code generationmodule.GenerationReadingProfile}
 */
public final class GenerationReadingProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.GenerationReadingProfile)
    GenerationReadingProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use GenerationReadingProfile.newBuilder() to construct.
  private GenerationReadingProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private GenerationReadingProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new GenerationReadingProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationReadingProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationReadingProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.GenerationReadingProfile.class, openfmb.generationmodule.GenerationReadingProfile.Builder.class);
  }

  public static final int READINGMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ReadingMessageInfo readingMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the readingMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasReadingMessageInfo() {
    return readingMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The readingMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMessageInfo getReadingMessageInfo() {
    return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMessageInfoOrBuilder getReadingMessageInfoOrBuilder() {
    return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
  }

  public static final int GENERATINGUNIT_FIELD_NUMBER = 2;
  private openfmb.generationmodule.GeneratingUnit generatingUnit_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the generatingUnit field is set.
   */
  @java.lang.Override
  public boolean hasGeneratingUnit() {
    return generatingUnit_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The generatingUnit.
   */
  @java.lang.Override
  public openfmb.generationmodule.GeneratingUnit getGeneratingUnit() {
    return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.GeneratingUnitOrBuilder getGeneratingUnitOrBuilder() {
    return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
  }

  public static final int GENERATIONREADING_FIELD_NUMBER = 3;
  private openfmb.generationmodule.GenerationReading generationReading_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the generationReading field is set.
   */
  @java.lang.Override
  public boolean hasGenerationReading() {
    return generationReading_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The generationReading.
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationReading getGenerationReading() {
    return generationReading_ == null ? openfmb.generationmodule.GenerationReading.getDefaultInstance() : generationReading_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationReadingOrBuilder getGenerationReadingOrBuilder() {
    return generationReading_ == null ? openfmb.generationmodule.GenerationReading.getDefaultInstance() : generationReading_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (readingMessageInfo_ != null) {
      output.writeMessage(1, getReadingMessageInfo());
    }
    if (generatingUnit_ != null) {
      output.writeMessage(2, getGeneratingUnit());
    }
    if (generationReading_ != null) {
      output.writeMessage(3, getGenerationReading());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (readingMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getReadingMessageInfo());
    }
    if (generatingUnit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getGeneratingUnit());
    }
    if (generationReading_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getGenerationReading());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.GenerationReadingProfile)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.GenerationReadingProfile other = (openfmb.generationmodule.GenerationReadingProfile) obj;

    if (hasReadingMessageInfo() != other.hasReadingMessageInfo()) return false;
    if (hasReadingMessageInfo()) {
      if (!getReadingMessageInfo()
          .equals(other.getReadingMessageInfo())) return false;
    }
    if (hasGeneratingUnit() != other.hasGeneratingUnit()) return false;
    if (hasGeneratingUnit()) {
      if (!getGeneratingUnit()
          .equals(other.getGeneratingUnit())) return false;
    }
    if (hasGenerationReading() != other.hasGenerationReading()) return false;
    if (hasGenerationReading()) {
      if (!getGenerationReading()
          .equals(other.getGenerationReading())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasReadingMessageInfo()) {
      hash = (37 * hash) + READINGMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getReadingMessageInfo().hashCode();
    }
    if (hasGeneratingUnit()) {
      hash = (37 * hash) + GENERATINGUNIT_FIELD_NUMBER;
      hash = (53 * hash) + getGeneratingUnit().hashCode();
    }
    if (hasGenerationReading()) {
      hash = (37 * hash) + GENERATIONREADING_FIELD_NUMBER;
      hash = (53 * hash) + getGenerationReading().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationReadingProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.GenerationReadingProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation reading profile
   * </pre>
   *
   * Protobuf type {@code generationmodule.GenerationReadingProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.GenerationReadingProfile)
      openfmb.generationmodule.GenerationReadingProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationReadingProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationReadingProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.GenerationReadingProfile.class, openfmb.generationmodule.GenerationReadingProfile.Builder.class);
    }

    // Construct using openfmb.generationmodule.GenerationReadingProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      readingMessageInfo_ = null;
      if (readingMessageInfoBuilder_ != null) {
        readingMessageInfoBuilder_.dispose();
        readingMessageInfoBuilder_ = null;
      }
      generatingUnit_ = null;
      if (generatingUnitBuilder_ != null) {
        generatingUnitBuilder_.dispose();
        generatingUnitBuilder_ = null;
      }
      generationReading_ = null;
      if (generationReadingBuilder_ != null) {
        generationReadingBuilder_.dispose();
        generationReadingBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationReadingProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationReadingProfile getDefaultInstanceForType() {
      return openfmb.generationmodule.GenerationReadingProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationReadingProfile build() {
      openfmb.generationmodule.GenerationReadingProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationReadingProfile buildPartial() {
      openfmb.generationmodule.GenerationReadingProfile result = new openfmb.generationmodule.GenerationReadingProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.GenerationReadingProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.readingMessageInfo_ = readingMessageInfoBuilder_ == null
            ? readingMessageInfo_
            : readingMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.generatingUnit_ = generatingUnitBuilder_ == null
            ? generatingUnit_
            : generatingUnitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.generationReading_ = generationReadingBuilder_ == null
            ? generationReading_
            : generationReadingBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.GenerationReadingProfile) {
        return mergeFrom((openfmb.generationmodule.GenerationReadingProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.GenerationReadingProfile other) {
      if (other == openfmb.generationmodule.GenerationReadingProfile.getDefaultInstance()) return this;
      if (other.hasReadingMessageInfo()) {
        mergeReadingMessageInfo(other.getReadingMessageInfo());
      }
      if (other.hasGeneratingUnit()) {
        mergeGeneratingUnit(other.getGeneratingUnit());
      }
      if (other.hasGenerationReading()) {
        mergeGenerationReading(other.getGenerationReading());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getReadingMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getGeneratingUnitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getGenerationReadingFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ReadingMessageInfo readingMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder> readingMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the readingMessageInfo field is set.
     */
    public boolean hasReadingMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The readingMessageInfo.
     */
    public openfmb.commonmodule.ReadingMessageInfo getReadingMessageInfo() {
      if (readingMessageInfoBuilder_ == null) {
        return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
      } else {
        return readingMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setReadingMessageInfo(openfmb.commonmodule.ReadingMessageInfo value) {
      if (readingMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        readingMessageInfo_ = value;
      } else {
        readingMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setReadingMessageInfo(
        openfmb.commonmodule.ReadingMessageInfo.Builder builderForValue) {
      if (readingMessageInfoBuilder_ == null) {
        readingMessageInfo_ = builderForValue.build();
      } else {
        readingMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeReadingMessageInfo(openfmb.commonmodule.ReadingMessageInfo value) {
      if (readingMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          readingMessageInfo_ != null &&
          readingMessageInfo_ != openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance()) {
          getReadingMessageInfoBuilder().mergeFrom(value);
        } else {
          readingMessageInfo_ = value;
        }
      } else {
        readingMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearReadingMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      readingMessageInfo_ = null;
      if (readingMessageInfoBuilder_ != null) {
        readingMessageInfoBuilder_.dispose();
        readingMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ReadingMessageInfo.Builder getReadingMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getReadingMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ReadingMessageInfoOrBuilder getReadingMessageInfoOrBuilder() {
      if (readingMessageInfoBuilder_ != null) {
        return readingMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return readingMessageInfo_ == null ?
            openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder> 
        getReadingMessageInfoFieldBuilder() {
      if (readingMessageInfoBuilder_ == null) {
        readingMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder>(
                getReadingMessageInfo(),
                getParentForChildren(),
                isClean());
        readingMessageInfo_ = null;
      }
      return readingMessageInfoBuilder_;
    }

    private openfmb.generationmodule.GeneratingUnit generatingUnit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder> generatingUnitBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the generatingUnit field is set.
     */
    public boolean hasGeneratingUnit() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The generatingUnit.
     */
    public openfmb.generationmodule.GeneratingUnit getGeneratingUnit() {
      if (generatingUnitBuilder_ == null) {
        return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
      } else {
        return generatingUnitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGeneratingUnit(openfmb.generationmodule.GeneratingUnit value) {
      if (generatingUnitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        generatingUnit_ = value;
      } else {
        generatingUnitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGeneratingUnit(
        openfmb.generationmodule.GeneratingUnit.Builder builderForValue) {
      if (generatingUnitBuilder_ == null) {
        generatingUnit_ = builderForValue.build();
      } else {
        generatingUnitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeGeneratingUnit(openfmb.generationmodule.GeneratingUnit value) {
      if (generatingUnitBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          generatingUnit_ != null &&
          generatingUnit_ != openfmb.generationmodule.GeneratingUnit.getDefaultInstance()) {
          getGeneratingUnitBuilder().mergeFrom(value);
        } else {
          generatingUnit_ = value;
        }
      } else {
        generatingUnitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearGeneratingUnit() {
      bitField0_ = (bitField0_ & ~0x00000002);
      generatingUnit_ = null;
      if (generatingUnitBuilder_ != null) {
        generatingUnitBuilder_.dispose();
        generatingUnitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GeneratingUnit.Builder getGeneratingUnitBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getGeneratingUnitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GeneratingUnitOrBuilder getGeneratingUnitOrBuilder() {
      if (generatingUnitBuilder_ != null) {
        return generatingUnitBuilder_.getMessageOrBuilder();
      } else {
        return generatingUnit_ == null ?
            openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder> 
        getGeneratingUnitFieldBuilder() {
      if (generatingUnitBuilder_ == null) {
        generatingUnitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder>(
                getGeneratingUnit(),
                getParentForChildren(),
                isClean());
        generatingUnit_ = null;
      }
      return generatingUnitBuilder_;
    }

    private openfmb.generationmodule.GenerationReading generationReading_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationReading, openfmb.generationmodule.GenerationReading.Builder, openfmb.generationmodule.GenerationReadingOrBuilder> generationReadingBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the generationReading field is set.
     */
    public boolean hasGenerationReading() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The generationReading.
     */
    public openfmb.generationmodule.GenerationReading getGenerationReading() {
      if (generationReadingBuilder_ == null) {
        return generationReading_ == null ? openfmb.generationmodule.GenerationReading.getDefaultInstance() : generationReading_;
      } else {
        return generationReadingBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGenerationReading(openfmb.generationmodule.GenerationReading value) {
      if (generationReadingBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        generationReading_ = value;
      } else {
        generationReadingBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGenerationReading(
        openfmb.generationmodule.GenerationReading.Builder builderForValue) {
      if (generationReadingBuilder_ == null) {
        generationReading_ = builderForValue.build();
      } else {
        generationReadingBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeGenerationReading(openfmb.generationmodule.GenerationReading value) {
      if (generationReadingBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          generationReading_ != null &&
          generationReading_ != openfmb.generationmodule.GenerationReading.getDefaultInstance()) {
          getGenerationReadingBuilder().mergeFrom(value);
        } else {
          generationReading_ = value;
        }
      } else {
        generationReadingBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearGenerationReading() {
      bitField0_ = (bitField0_ & ~0x00000004);
      generationReading_ = null;
      if (generationReadingBuilder_ != null) {
        generationReadingBuilder_.dispose();
        generationReadingBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationReading.Builder getGenerationReadingBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getGenerationReadingFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationReadingOrBuilder getGenerationReadingOrBuilder() {
      if (generationReadingBuilder_ != null) {
        return generationReadingBuilder_.getMessageOrBuilder();
      } else {
        return generationReading_ == null ?
            openfmb.generationmodule.GenerationReading.getDefaultInstance() : generationReading_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationReading generationReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationReading, openfmb.generationmodule.GenerationReading.Builder, openfmb.generationmodule.GenerationReadingOrBuilder> 
        getGenerationReadingFieldBuilder() {
      if (generationReadingBuilder_ == null) {
        generationReadingBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.GenerationReading, openfmb.generationmodule.GenerationReading.Builder, openfmb.generationmodule.GenerationReadingOrBuilder>(
                getGenerationReading(),
                getParentForChildren(),
                isClean());
        generationReading_ = null;
      }
      return generationReadingBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.GenerationReadingProfile)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.GenerationReadingProfile)
  private static final openfmb.generationmodule.GenerationReadingProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.GenerationReadingProfile();
  }

  public static openfmb.generationmodule.GenerationReadingProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GenerationReadingProfile>
      PARSER = new com.google.protobuf.AbstractParser<GenerationReadingProfile>() {
    @java.lang.Override
    public GenerationReadingProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<GenerationReadingProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GenerationReadingProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.GenerationReadingProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

